@ECHO OFF

:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: WORDFIND.BAT                                                            :: 
:: By Dan McCarthy, N2PTG                                                  :: 
:: Rochester, NY                                                           :: 
::                                                                         ::
:: For MS and PC DOS Version 5 or later                                    :: 
:: Type WORDFIND WORD WORD WORD WORD WORD WORD.... to run                  :: 
:: Example: WORDFIND PRINT ACCOUNT TRANSACTION PROCESSING COMPUTER         :: 
:: The above command is not case sensitive                                 ::
::                                                                         ::
:: Install this and any other batch file into a directory that is included ::
:: in the PATH statement of your AUTOEXEC.BAT file. By doing this, the     ::
:: batch file will execute from any directory or subdirectory. You can     ::
:: create a directory called C:\BAT, for example, and copy all your batch  ::
:: files into it. Then include C:\BAT in the PATH statement of the         ::
:: AUTOEXEC.BAT file.                                                      ::
::                                                                         ::
:: WORDFIND.BAT uses the FIND command. The FIND DOS command, in itself,    ::
:: does not support wildcard characters or multiple words. By using FIND   ::
:: in conjunction with the FOR command and BATCH PARAMETERS, however, you  ::
:: can search all files for more than one word.                            ::
::                                                                         ::
:: WORDFIND.BAT searches all the files in the directory or subdirectory    ::
:: of the fixed or floppy drive that you are currently logged on to.       ::
:: WORDFIND.BAT will search for occurrences of a character string without  ::
:: regard to case. As long as the characters are in sequence, it will      ::
:: locate them. If, for example, you are looking for the word "print",     ::
:: words like "printed", "printing", "PRINT", "PrINt", "Printout",         ::
:: "printable", "XXXprintXXX", or "imprinted" etc. will be regarded as     ::
:: "hits" (matches). WARNING! Always use the root of the word you want to  ::
:: find, where applicable, to maximize the number of hits. From the same   ::                                                                     
:: example used above, if you had searched for the word "printer" instead  ::
:: of "print", you would not have gotten any matches. If you are searching ::
:: for an abbreviation such as "Y.M.C.A.", make sure you specify the string::                                                                            
:: both with and without periods between letters. Otherwise all occurrences:: 
:: won't be found. For the example above, type WORDFIND Y.M.C.A. YMCA at   ::
:: the command line.                                                       ::
::                                                                         ::
:: The data generated by WORDFIND.BAT is output to the now to be created   ::
:: text file WORDFIND.TXT, located in the hard drive's root directory "C:".::   
:: You may view, edit, print, and save the data in the WORDFIND.TXT file,  ::   
:: using any text editor such as the DOS EDITOR. Save your data under      ::
:: another filename ("SAVE AS") because every time WORDFIND.BAT is run,    ::   
:: WORDFIND.TXT is purged of all previous data.                            ::                                                                                       
::                                                                         ::
:: In the text editor, view WORDFIND.TXT. In the file, you will see lists  ::  
:: of files that were searched, in the order that they appear in the source:: 
:: directory. There will be one identical list for each word on the        ::
:: WORDFIND.BAT command line, starting with the first word on the left.    ::  
:: There will be no break or space between lists, so note the first file   :: 
:: in the list. When it occurs again, the next list has started. The       ::  
:: listings will allow you to view the words and their context, at each    ::
:: numbered line location in the file(s) that contain them. Files that do  ::
:: not contain an occurrence of the word will also be listed.              ::                                                                       
::                                                                         ::
:: You can view a complete file from any text editor or the DOS SHELL.     ::
::                                                                         ::
:: If your hard drive's root directory has a letter other than "C:"        ::
:: assigned to it, or if you want WORDFIND.TXT to be located in a different:: 
:: directory, change the following 3 lines in this batch file to reflect   ::
:: the correct location:                                                   ::                      
::   DEL C:\WORDFIND.TXT  (Line 83)                                        ::
::   FOR %%F IN (*.*) DO FIND /I /N "%1" %%F >> C:\WORDFIND.TXT  (Line 101)::
::   EDIT C:\WORDFIND.TXT  (Line 118)                                      ::                 
::                                                                         ::
:: Other files used with WORDFIND.BAT are SCANCODE.COM AND EJECT.BAT.      :: 
:: They are included with WORDFIND.BAT in the WORDFIND.ZIP File.           ::                           
:: UNZIP them before using.                                                ::   
:: You can print a hard copy of WORDFIND.BAT from the DOS Editor.          :: 
::                                                                         ::
:: WORDFIND.BAT cannot search a compressed or zipped file. Files with the  :: 
:: following extensions should be expanded or unzipped before running      :: 
:: WORDFIND.BAT: .ZIP, .SIT, .SEA, .LHA, or .ARC                           :: 
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

CLS

IF '%1'==''        GOTO ERR1
IF NOT EXIST *.*   GOTO ERR4

DEL C:\WORDFIND.TXT 

CLS
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
ECHO Please wait until the search is concluded. . . . 

:LOOP
IF '%1P'=='P' GOTO EDIT
FOR %%F IN (*.*) DO FIND /I /N "%1" %%F >> C:\WORDFIND.TXT 
SHIFT
GOTO LOOP

:EDIT
CLS
ECHO Would you like to display WORDFIND.TXT in the DOS Editor now?
ECHO.
ECHO Please enter Y or N
SCANCODE
IF ERRORLEVEL 50 GOTO ERR2
IF ERRORLEVEL 49 GOTO CONCLUDE
IF ERRORLEVEL 22 GOTO ERR2
IF ERRORLEVEL 21 GOTO DISPLAY
IF ERRORLEVEL 1  GOTO ERR2

:DISPLAY
EDIT C:\WORDFIND.TXT

:PRINT
CLS
ECHO If you used the "PRINT" command in the DOS EDITOR and you did not receive
ECHO a printout, or the printout was not complete, type P (Print) or N (No) at 
ECHO the prompt.
ECHO.
ECHO Enter your choice P or N:
SCANCODE
IF ERRORLEVEL 50 GOTO ERR3
IF ERRORLEVEL 49 GOTO CONCLUDE
IF ERRORLEVEL 26 GOTO ERR3
IF ERRORLEVEL 25 GOTO CLEAR
IF ERRORLEVEL 1  GOTO ERR3

:CLEAR
CALL EJECT.BAT      //clears the print buffer & ejects a partial page
GOTO CONCLUDE

:ERR1
CLS
ECHO                                  ************
ECHO                                  SYNTAX ERROR
ECHO                                  ************
ECHO.
ECHO.
ECHO.
ECHO Please try again. When you execute WORDFIND.BAT, you must provide the name
ECHO of the word or words that you are searching for, separated by spaces.
ECHO.
ECHO.
ECHO Example: WORDFIND PASSWORD SECRET DOWNLINK CODEWORD FREQUENCY RAAN R.A.A.N. 
ECHO             
ECHO.
ECHO.
ECHO.
ECHO The command is not case sensitive.
ECHO.
ECHO.
GOTO END

:ERR2
CLS
ECHO You entered an incorrect option!
ECHO Please type Y or N
SCANCODE
IF ERRORLEVEL 50 GOTO ERR2
IF ERRORLEVEL 49 GOTO CONCLUDE
IF ERRORLEVEL 22 GOTO ERR2
IF ERRORLEVEL 21 GOTO DISPLAY
IF ERRORLEVEL 1  GOTO ERR2

:ERR3
CLS
ECHO You entered an incorrect option!
ECHO Please type P or N:
SCANCODE
IF ERRORLEVEL 50 GOTO ERR3
IF ERRORLEVEL 49 GOTO CONCLUDE
IF ERRORLEVEL 26 GOTO ERR3
IF ERRORLEVEL 25 GOTO CLEAR
IF ERRORLEVEL 1  GOTO ERR3

:ERR4
CLS
ECHO.
ECHO.
ECHO                              ͻ
ECHO                                EMPTY DIRECTORY! 
ECHO                              ͼ
ECHO.
ECHO.
ECHO.
ECHO.
ECHO The directory you chose to search is empty. There might be subdirectories 
ECHO of this directory, however, that contain files you can search. Use the
ECHO "DIR" command now to confirm this. Then change to the subdirectory and 
ECHO run WORDFIND.BAT again.
ECHO.
ECHO.
ECHO.
GOTO END 

:CONCLUDE
CLS
ECHO                            ***************************
ECHO                            THIS CONCLUDES WORDFIND.BAT
ECHO                            ***************************
ECHO.
ECHO.

:END
ECHO.
ECHO.

